-- Farben.lua

print("Lua - Isch jebb die Namen wech")

Portnamen = 
	{
		"External A", "External  B", "External  C", "External D", "Internal"
	}

Portname = function(x) return Portnamen[x + 1] end

PortnamenKurz = 
	{
		"A", "B", "C", "D", "I"
	}

PortnameKurz = function(x) return PortnamenKurz[x + 1] end

Statusnamen = {}
Statusnamen[0x00] = "Sequence"
Statusnamen[0x01] = "Text"
Statusnamen[0x02] = "Copyright"
Statusnamen[0x03] = "Track Name"
Statusnamen[0x04] = "Instrument"
Statusnamen[0x05] = "Lyrics"
Statusnamen[0x06] = "Marker"
Statusnamen[0x07] = "Cue Point"
Statusnamen[0x20] = "Channel"
Statusnamen[0x21] = "Port"
Statusnamen[0x80] = "Key Off"
Statusnamen[0x90] = "Key On"
Statusnamen[0xA0] = "Key Pressure"
Statusnamen[0xB0] = "Control"
Statusnamen[0xC0] = "Program Change"
Statusnamen[0xD0] = "Chan. Pressure"
Statusnamen[0xE0] = "Pitch Bend"
Statusnamen[0xF3] = "Song Select"
Statusnamen[0xFA] = "Start Playback"
Statusnamen[0xFC] = "Stop Playback"
Statusnamen[0x51] = "Tempo"
Statusnamen[0x58] = "Time Signature"
Statusnamen[0x59] = "Key Signature"
Statusnamen[0xF0] = "SysEx"

Statusname = function(x) return Statusnamen[x] end

Kanalname = function(x) if x < 0 or x > 15 then return "all" else return tostring(x + 1) end end

Raummassname = function(x) return tostring((x + 1)  * 5) .. "m" end

Tonnamen = { "c", "c#", "d", "d#", "e", "f", "f#", "g", "g#", "a", "a#", "b" }

Tonname = function(x)
	q = math.floor(x / 12)
	m = x - q * 12
	return Tonnamen[1 + m] .. tostring(q)
end

GMIDrumnamen =
{
	"Acoustic BD",	-- (35)
	"Bass Drum1",
	"Side Stick",
	"Acoustic Snare",
	"Hand Clap",
	"Electric Snare",
	"Low Floor Tom",
	"Closed Hi-Hat",
	"High Floor Tom",
	"Pedal Hi-Hat",
	"Low Tom",
	"Open Hi-Hat",
	"Low-Mid Tom",
	"Hi-Mid Tom",
	"Crash Cymbal 1",
	"High Tom",
	"Ride Cymbal 1",
	"Chinese Cymbal",
	"Ride Bell",
	"Tambourine",
	"Splash Cymbal",
	"Cowbell",
	"Crash Cymbal 2",
	"Vibraslap",
	"Ride Cymbal 2",
	"Hi Bongo",
	"Low Bongo",
	"Mute Hi Conga",
	"Open Hi Conga",
	"Low Conga",
	"High Timbale",
	"Low Timbale",
	"High Agogo",
	"Low Agogo",
	"Cabasa",
	"Maracas",
	"Short Whistle",
	"Long Whistle",
	"Short Guiro",
	"Long Guiro",
	"Claves",
	"Hi Wood Block",
	"Low Wood Block",
	"Mute Cuica",
	"Open Cuica",
	"Mute Triangle",
	"Open Triangle",
	"Shaker"
}

GMIDrumname = function(x)
	if
		x < 35 or x > 82
	then
		Ergebnis = "Key #" .. tostring(x)
	else
		Ergebnis = GMIDrumnamen[x - 34]
	end
	return Ergebnis
end

Tonklassennamen = 
{ 
	"Abb", "Ab", "A", "A#", "A##",
	"Bbb", "Bb", "B", "B#", "B##",
	"Cbb", "Cb", "C", "C#", "C##",
	"Dbb", "Db", "D", "D#", "D##",
	"Ebb", "Eb", "E", "E#", "E##",
	"Fbb", "Fb", "F", "F#", "F##",
	"Gbb", "Gb", "G", "G#", "G##",
	"A--", "A-", "A+", "A++",
	"A#--",
	"Bb--", "Bb-", "Bb+", "Bb++", 
	"B--", "B-", "B+", "B++", 
	"Cb++",
	"C--", "C-", "C+", 
	"C#--", "C#-", "C#+", "C#++", 
	"Db--", "Db-", "Db+", "Db++", 
	"D--", "D-", "D+", "D++", 
	"D#--", "D#-", "D#+", 
	"Eb--", "Eb-", "Eb+", "Eb++", 
	"E--", "E-", "E+", "E++", 
	"E#-", 
	"Fb++", "F--", "F-", "F+", "F++",  
	"F#--", "F#-", "F#+", "F#++", 
	"Gb--", "Gb-", "Gb++", 
	"G--", "G-", "G+", "G++", 
	"G#--", "G#-", "G#+", "G#++", 
	"Ab--", "Ab-", "Ab+", "Ab++"
}
Tonklassenname = function(x) return Tonklassennamen[x + 1] end

Zahlname = function(x) return tostring(x) end

Tonartnamen = {}
Tonartnamen[0x0000] = "C Major"
Tonartnamen[0x0100] = "G Major"
Tonartnamen[0x0200] = "D Major"
Tonartnamen[0x0300] = "A Major"
Tonartnamen[0x0400] = "E Major"
Tonartnamen[0x0500] = "B Major"
Tonartnamen[0x0600] = "F# Major"
Tonartnamen[0x0700] = "C# Major"
Tonartnamen[0xFF00] = "F Major"
Tonartnamen[0xFE00] = "Bb Major"
Tonartnamen[0xFD00] = "Eb Major"
Tonartnamen[0xFC00] = "Ab Major"
Tonartnamen[0xFB00] = "Db Major"
Tonartnamen[0xFA00] = "Gb Major"
Tonartnamen[0xF900] = "Cb Major"
Tonartnamen[0x0001] = "A Minor"
Tonartnamen[0x0101] = "E Minor"
Tonartnamen[0x0201] = "B Minor"
Tonartnamen[0x0301] = "F# Minor"
Tonartnamen[0x0401] = "C# Minor"
Tonartnamen[0x0501] = "G# Minor"
Tonartnamen[0x0601] = "D# Minor"
Tonartnamen[0x0701] = "A# Minor"
Tonartnamen[0xFF01] = "D Minor"
Tonartnamen[0xFE01] = "G Minor"
Tonartnamen[0xFD01] = "C Minor"
Tonartnamen[0xFC01] = "F Minor"
Tonartnamen[0xFB01] = "Bb Minor"
Tonartnamen[0xFA01] = "Eb Minor"
Tonartnamen[0xF901] = "Ab Minor"

Tonartname_nach_Code = function(x) return Tonartnamen[x] end

ControllernamenLang = {
	"Bank select MSB",
	"Modulation" 					,
	"Breath Controller",
	"Undefined (4)" 					,
	"Foot Controller",
	"Portamento Time",
	"Data Byte",
	"Main Volume",
	"Balance",
	"Undefined (10)",
	"Panorama",
	"Expression",
	"Effect Control 1",
	"Effect Control 2",
	"Undefined (14)",
	"Undefined (15)",
	"General Purpose Controllers 1",
	"General Purpose Controllers 2",
	"General Purpose Controllers 3",
	"General Purpose Controllers 4",
	"Undefined (20)",
	"Undefined (21)",
	"Undefined (22)",
	"Undefined (23)",
	"Undefined (24)",
	"Undefined (25)",
	"Undefined (26)",
	"Undefined (27)",
	"Undefined (28)",
	"Undefined (29)",
	"Undefined (30)",
	"Undefined (31)",
	"Bank select LSB",
	"Modulation LSB",
	"Breath Controller LSB",
	"Undefined (35)",
	"Foot Controller LSB",
	"Portamento Time",
	"Undefined (38)",
	"Main Volume LSB",
	"Balance LSB"	,
	"Undefined (41)",
	"Panorama LSB"	,
	"Expression LSB",
	"[HVC X-Axis]",
	"[HVC Y-Axis]",
	"[HVC Z-Axis]",
	"Undefined (47)",
	"General Purpose Controllers 1 LSB",
	"General Purpose Controllers 2 LSB",
	"General Purpose Controllers 3 LSB",
	"General Purpose Controllers 4 LSB",
	"Undefined (52)",
	"Undefined (53)",
	"Undefined (54)",
	"Undefined (55)",
	"Undefined (56)",
	"Undefined (57)",
	"Undefined (58)",
	"Undefined (59)",
	"Undefined (60)",
	"Undefined (61)",
	"Undefined (62)",
	"Undefined (63)",
	"Hold 1"		,
	"Portamento"	,
	"Sostenuto"		,
	"Soft Pedal"	,
	"Legato Footswitch",
	"Hold 2",
	"Sound Controller 1 (Sound Variation)",
	"Sound Controller 2 (Harmonic Content)",
	"Sound Controller 3 (Release Time)",
	"Sound Controller 4 (Attack Time)",
	"Sound Controller 5 (Brightness)",
	"Sound Controller 6",
	"Sound Controller 7",
	"Sound Controller 8",
	"Sound Controller 9",
	"Sound Controller 10",
	"General Purpose Button 1",
	"General Purpose Button 2",
	"General Purpose Button 3",
	"General Purpose Button 4",
	"Portamento Control",
	"Undefined (85)",
	"Undefined (86)",
	"Undefined (87)",
	"Undefined (88)",
	"Undefined (89)",
	"Undefined (90)",
	"Effects 1 Depth",
	"Effects 2 Depth",
	"Effects 3 Depth",
	"Effects 4 Depth",
	"Effects 5 Depth",
	"Data Increment RPN/NRPN",
	"Data Decrement RPN/NRPN",
	"NRPN LSB",
	"NRPN MSB",
	"RPN LSB",
	"RPN MSB",
	"Undefined (102)",
	"Undefined (103)",
	"Undefined (104)",
	"Undefined (105)",
	"Undefined (106)",
	"Undefined (107)",
	"Undefined (108)",
	"Undefined (109)",
	"Undefined (110)",
	"Undefined (111)",
	"Undefined (112)",
	"Undefined (113)",
	"Undefined (114)",
	"Undefined (115)",
	"Undefined (116)",
	"Undefined (117)",
	"Undefined (118)",
	"Undefined (119)",
	"All Sounds Off",
	"Controller Reset",
	"Local Control On/Off",
	"All Notes Off",
	"Omni Off",
	"Omni On",
	"Mono On / Poly Off",
	"Poly on / Mono Off"
}

ControllernameLang = function(x) return ControllernamenLang[x + 1] end

ControllernamenKurz = {
	"Bank select MSB",
	"Modulation" 					,
	"Breath Controller",
	"Undefined (4)" 					,
	"Foot Controller",
	"Portamento Time",
	"Data Byte",
	"Main Volume",
	"Balance",
	"Undefined (10)",
	"Panorama",
	"Expression",
	"Effect Control 1",
	"Effect Control 2",
	"Undefined (14)",
	"Undefined (15)",
	"GPC 1",
	"GPC 2",
	"GPC 3",
	"GPC 4",
	"Undefined (20)",
	"Undefined (21)",
	"Undefined (22)",
	"Undefined (23)",
	"Undefined (24)",
	"Undefined (25)",
	"Undefined (26)",
	"Undefined (27)",
	"Undefined (28)",
	"Undefined (29)",
	"Undefined (30)",
	"Undefined (31)",
	"Bank select LSB",
	"Modulation LSB",
	"Breath Controller LSB",
	"Undefined (35)",
	"Foot Controller LSB",
	"Portamento Time",
	"Undefined (38)",
	"Main Volume LSB",
	"Balance LSB"	,
	"Undefined (41)",
	"Panorama LSB"	,
	"Expression LSB",
	"[HVC X-Axis]",
	"[HVC Y-Axis]",
	"[HVC Z-Axis]",
	"Undefined (47)",
	"GPC 1 LSB",
	"GPC 2 LSB",
	"GPC 3 LSB",
	"GPC 4 LSB",
	"Undefined (52)",
	"Undefined (53)",
	"Undefined (54)",
	"Undefined (55)",
	"Undefined (56)",
	"Undefined (57)",
	"Undefined (58)",
	"Undefined (59)",
	"Undefined (60)",
	"Undefined (61)",
	"Undefined (62)",
	"Undefined (63)",
	"Hold 1"		,
	"Portamento"	,
	"Sostenuto"		,
	"Soft Pedal"	,
	"Legato Footswitch",
	"Hold 2",
	"Sound Controller 1",
	"Sound Controller 2",
	"Sound Controller 3",
	"Sound Controller 4",
	"Sound Controller 5",
	"Sound Controller 6",
	"Sound Controller 7",
	"Sound Controller 8",
	"Sound Controller 9",
	"Sound Controller 10",
	"GPB 1",
	"GPB 2",
	"GPB 3",
	"GPB 4",
	"Portamento Control",
	"Undefined (85)",
	"Undefined (86)",
	"Undefined (87)",
	"Undefined (88)",
	"Undefined (89)",
	"Undefined (90)",
	"Effects 1 Depth",
	"Effects 2 Depth",
	"Effects 3 Depth",
	"Effects 4 Depth",
	"Effects 5 Depth",
	"Data Increment RPN/NRPN",
	"Data Decrement RPN/NRPN",
	"NRPN LSB",
	"NRPN MSB",
	"RPN LSB",
	"RPN MSB",
	"Undefined (102)",
	"Undefined (103)",
	"Undefined (104)",
	"Undefined (105)",
	"Undefined (106)",
	"Undefined (107)",
	"Undefined (108)",
	"Undefined (109)",
	"Undefined (110)",
	"Undefined (111)",
	"Undefined (112)",
	"Undefined (113)",
	"Undefined (114)",
	"Undefined (115)",
	"Undefined (116)",
	"Undefined (117)",
	"Undefined (118)",
	"Undefined (119)",
	"All Sounds Off",
	"Controller Reset",
	"Local Control On/Off",
	"All Notes Off",
	"Omni Off",
	"Omni On",
	"Mono On / Poly Off",
	"Poly on / Mono Off"
}

ControllernameKurz = function(x) return ControllernamenKurz[x + 1] end

Programmnamen = {
	"Acoustic Grand",
	"Bright Piano",
	"Electric Grand",
	"Honky-Tonk",
	"E. Piano 1",
	"E. Piano 2",
	"Harpsichord",
	"Clavinet",
	"Celesta",
	"Glockenspiel",
	"Music Box",
	"Vibraphone",
	"Marimba",
	"Xylophone",
	"Tubular Bells",
	"Dulcimer",
	"Draw Organ",
	"Percussive Organ",
	"Rock Organ",
	"Church Organ",
	"Reed Organ",
	"Accordion",
	"Harmonica",
	"Tango Acc.",
	"Nylonstr. Gt.",
	"Steelstr. Gt.",
	"Jazz. Gt.",
	"Clean Gt.",
	"Muted Gt.",
	"Overdrive Gt.",
	"Distortion Gt.",
	"Gt. Harmonics",
	"Acoustic Bass",
	"Fingered Bass",
	"Picked Bass",
	"Fretless Bass",
	"Slap Bass 1",
	"Slap Bass 2",
	"Synth Bass 1",
	"Synth Bass 2",
	"Violin",
	"Viola",
	"Cello",
	"Contrabass",
	"Tremolo Strings",
	"Pizzicato",
	"Harp",
	"Timpani",
	"Strings",
	"Slow Strings",
	"Syn. Strings 1",
	"Syn. Strings 2",
	"Choir Aahs",
	"Voice Oohs",
	"Syn Vox",
	"Orchestra Hit",
	"Trumpet",
	"Trombone",
	"Tuba",
	"Muted Trumpet",
	"French Horn",
	"Brass",
	"Synth Brass 1",
	"Synth Brass 2",
	"Soprano Sax",
	"Alto Sax",
	"Tenor Sax",
	"Baritone Sax",
	"Oboe",
	"English Horn",
	"Bassoon",
	"Clarinet",
	"Piccolo",
	"Flute",
	"Recorder",
	"Pan Flute",
	"Blown Bottle",
	"Shakuhachi",
	"Whistle",
	"Ocarina",
	"Square Wave",
	"Saw Wave",
	"Syn. Calliope",
	"Chiffer Lead",
	"Charang",
	"Solo Vox",
	"5th Saw Wave",
	"Bass + Lead",
	"Fantasia",
	"Warm Pad",
	"Polysynth",
	"Space Voice",
	"Bowed Glass",
	"Metal Pad",
	"Halo Pad",
	"Sweep Pad",
	"FX Ice Rain",
	"FX Soundtrack",
	"FX Crystal",
	"FX Atmosphere",
	"FX Brightness",
	"FX Goblin",
	"FX Echo Drops",
	"FX Star Theme",
	"Sitar",
	"Banjo",
	"Shamisen",
	"Koto",
	"Kalimba",
	"Bag Pipe",
	"Fiddle",
	"Shenai",
	"Tinkle Bell",
	"Agogo",
	"Steel Drums",
	"Woodblock",
	"Taiko",
	"Melo Tom",
	"Synth Drum",
	"Reverse Cym.",
	"Gt. Fret Noise",
	"Breath Noise",
	"Sea Shore",
	"Bird",
	"Telephone",
	"Helicopter",
	"Applause",
	"Gun Shot"
}

Programmname = function(x) return Programmnamen[x + 1] end

Mausmodinamen = {}
Mausmodinamen[0x90D0] =	"Mouse Mode: Select"
Mausmodinamen[0x90D1] =	"Mouse Mode: Duplicate"
Mausmodinamen[0x90D2] =	"Mouse Mode: Shift"
Mausmodinamen[0x90D3] =	"Mouse Mode: Split"
Mausmodinamen[0x90D4] =	"Mouse Mode: Merge"
Mausmodinamen[0x90D5] =	"Mouse Mode: Size"
Mausmodinamen[0x90D6] =	"Mouse Mode: Draw"
Mausmodinamen[0x90D7] =	"Mouse Mode: Erase"

Mausmodusname = function(x) return Mausmodinamen[x] end

Teilungsmodusnamen = {}
Teilungsmodusnamen[0x9288] = "Division : 1/2"
Teilungsmodusnamen[0x9289] = "Division : 1/3"
Teilungsmodusnamen[0x928A] = "Division : 1/5"
Teilungsmodusnamen[0x928B] = "Division : 1/7"

Teilungsmodusname = function(x) return Teilungsmodusnamen[x] end

Halbtonmodusnamen = {}
Halbtonmodusnamen[0x9284] = "Accidentals : Key"
Halbtonmodusnamen[0x9285] = "Accidentals : None"
Halbtonmodusnamen[0x9286] = "Accidentals : Flat"
Halbtonmodusnamen[0x9287] = "Accidentals : Sharp"

Halbtonmodusname = function(x) return Halbtonmodusnamen[x] end

Snapnamen =  {}
Snapnamen[0x90F7] =	"off"
Snapnamen[0x90F0] =	"1 / 1"
Snapnamen[0x90F1] =	"1 / 2"
Snapnamen[0x90F8] =	"1 / 2T"
Snapnamen[0x90FE] =	"3 / 4"
Snapnamen[0x90F2] =	"1 / 4"
Snapnamen[0x90F9] =	"1 / 4T"
Snapnamen[0x90FF] =	"3 / 8"
Snapnamen[0x90F3] =	"1 / 8"
Snapnamen[0x90FA] =	"1 / 8T"
Snapnamen[0x9100] =	"3 / 16"
Snapnamen[0x90F4] =	"1 / 16"
Snapnamen[0x90FB] =	"1 / 16T"
Snapnamen[0x9101] =	"3 / 32"
Snapnamen[0x90F5] =	"1 / 32"
Snapnamen[0x90FC] =	"1 / 32T"
Snapnamen[0x9102] =	"3 / 64"

Quantvalids =  {
	0x90F0,
	0x90F1,
	0x90F8,
	0x90FE,
	0x90F2,
	0x90F9,
	0x90FF,
	0x90F3,
	0x90FA,
	0x9100,
	0x90F4,
	0x90FB,
	0x9101,
	0x90F5,
	0x90FC,
	0x9102
}

Snapname = function(x) return Snapnamen[x] end

Quantvalname = function(x) return Snapnamen[Quantvalids[x + 1]] end

Zeicheneventnamen = {
	"Event : Tempo",
	"Event : Pitch Bend",
	"Event : Channel Pressure",
	"Event : Modulation",
	"Event : Volume",
	"Event : Panorama",
	"Event : X",
	"Event : Y",
	"Event : Z",
	"Event : Balance",
	"Event : Expression"
}

Zeicheneventname = function(x) return Zeicheneventnamen[x + 1] end

Grundtonnamen = { "A", "A#", "Bb", "B", "Cb", "C", "C#", "Db", "D", "D#", "Eb", "E", "F", "F#", "Gb", "G", "G#", "Ab" }

Grundtonname = function(x) if x >= 0 then return Grundtonnamen[x + 1] else return " " end end

Stimmungsnamen = {
	"12-tone Equal Temperament",
	"Werckmeister's Temperament No. 3",
	"Werckmeister's Temperament No. 4",
	"Werckmeister's Temperament No. 5",
	"Werckmeister's Temperament No. 6",
	"Kirnberger's Temperament",
	-- "Chinese Mouth Organ Tuning",
	-- "Chinese Oboe Tuning",
	-- "Chinese Dulcimer Tuning",
	-- "Chinese Gong Chime Tuning",
	-- "Chinese Lute Tuning",
	-- "Chinese Tamboura Tuning",
	-- "Tibetan Buddhist Gyaling Tuning",
	"Pelog on Bem I",
	-- "Gamelan Saih Pitu",
	-- "Bamboo Gambang from Batu Lulan",
	-- "Gamelan Kyahi Munggang",
	-- "Gamelan Kantjilbelik",
	-- "Surupan Ajeng", 
	-- "Surupan Degung",
	-- "Surupan Madenda",
	-- "Surupan Melog",
	-- "Surupan Miring",
	"Rossi's Meantone",
	"7-Tone Equal Temperament",
	"Zarlino's Meantone",
	"9-Tone Equal Temperament",
	"Silbermann Organ Tuning",
	"10-Tone Equal Temperament from C",
	"22-Tone Equal Temperament from A",
	"22-Tone Equal Temperament from C",
	"40-Tone Equal Temperament from A",
	"40-Tone Equal Temperament from C",
	"53-tone Equal Temperament from A",
	"53-tone Equal Temperament from C",
	"Kepler's Monochord", 
	"Agricola's Monochord",
	"Terry Riley's 'Harp of New Albion' Scale",
	"35-tone Pythagoreaen",
	"Harry Partch's Pure Scale",
	"Danielou's Harmonic Division of the Octave",
	"Arabic Tuning (with Quartertones)",
	-- "Pythagorean Diatonic",
	"Ptolemy's Tuning",
	-- "Archytas' Diatonic",
	-- "Archytas' Chromatic",
	-- "Archytas' Enharmonic",
	"Arabic Pythagorean"
};

Stimmungsname = function(x) if x >= 0 then return Stimmungsnamen[x + 1] else return " " end end

Modusnamen = {
	-- Dodekatonik
	"Ascending Chromatic",
	"Descending Chromatic",
	-- "Hemitonic Pentatonic 1 (Rag Revati)",
	-- "Hemitonic Pentatonic 9 (Rag Vaijayanti)",
	-- "Hemitonic Pentatonic 13 (Hira-joshi)",
	-- "Hemitonic Pentatonic 15 (Rag Bhinn Shadja)",
	-- "Messiaen 4",
	-- "Messiaen 6",
	-- "Maqam Saba",
	-- "Ancient Enharmonic Mode",
	-- "Slendro II",
	-- "Manyura",
	-- "Safi al-Din's Maqam Husaini",
	-- "Safi al-Din's Maqam Iraq",
	"Rag Pilu",

	-- Dekatonik
	"Makam Buselik",
	"Messiaen's 7th mode",
	"Rag Sindhi Bhairavi",

	-- Nonatonik
	"Makam Buzurk",
	"Rag Nat",
	"Full Minor",
	"Makam Hisar",
	"Makam Arazbar",
	"Makam Kucek",
	"Rag Sindh Kafi",
	"Sadharanikrta Uttaramandra",
	"Sadharanikrta Suddhashadja",
	"Makam Hicazkar",
	"Makam Suzidil",
	"Messiaen's 3rd mode",
	"Sadharanikrta Rajani",
	"Sadharanikrta Uttarayata",
	"Rag Bhairavi",
	"Makam Kurdi",
	"Makam Suzinak",

	-- Oktatonik
	"Makam Rast",
	"Makam Zirgule",
	"Messiaen's 6th mode", 
	"Makam Nikriz",
	"Rag Bahar",
	"Makam Nisabur",
	"Makam Saba Zemzeme",
	"Makam Huzzam",
	"Makam Sedaraban",
	"Makam Hicaz",
	"Makam Iraq",
	"Makam Vechi Arazbar",
	"Diminished octatonic, Messiaen's 2nd mode", 
	"Messiaen's 4th mode", 

	-- Heptatonik
	"Mela Rasikapriya",
	"Mela Kosalam",
	"Hungarian Major, Mela Nasikabhushani",
	"Mela Dhatuvardhani",
	"Mela Jyotihsvarupini",
	"Mela Sucaritra",
	"Chromatic Phrygian",
	"Chromatic Dorian Inverse, Mela Calanata",
	"Mela Sulini",
	"Mela Vagadhishwari",
	"Mela Gangeyabhushani",
	"Mela Ragavardhini",
	"Mela Yagapriya",
	"Jazz minor 3rd mode (Lydian augmented)",
	"Mela Citrambari",
	-- Kalyan That
	"Murcchana Abhirudgata",
	"Rag Yaman",
	"Ancient Hypolydian, Medieval Lydian, Mela Mecakalyani", 
	"Rag Bihag",
	"Jazz minor 4th mode (Lydian dominant), Mela Vacaspati",	
	"Mela Latangi",	
	"Lydian Minor, Mela Rishabhapriya",
	"Mela Kantamani",
	"Augmented major 13th chord",	
	"Augmented 13th chord",	
	"Mela Naganandini",
	-- Bilawal That
	"Major, Major 13th chord, Ancient Lydian, Medieval Ionian, Mela Sankarabharanam",
	"Murcchana Rajani",
	"Rag Gopi Kambhoji",
	"Murcchana Margavi",
	"Maqam Jiharkah",
	"Maqam Rast",
	-- Khammaj That
	"Dominant 13th chord, Ancient Ionian, Medieval Mixolydian, Mela Harikambhoji",
	"Makam Sazkar, Rag Surat Malhar",
	"Makam Urmawi",
	"Safi al-Din's Maqam Rast",
	"Murcchana Asvakranta",
	"Safi al-Din's Maqam Zangulah",
	"Harmonic Major, Mela Sarasangi",
	"Jazz minor 5th mode (Mixolydian flat 6), Mela Carukesi",
	"Makam Nisaburek",
	"Safi al-Din's Maqam Rahawi",
	"Mela Mararanjani",
	"Major Locrian",
	"Mela Nitimati",	
	"Lydian Diminished, Mela Dharmavati",	
	"Mela Hemavati",	
	"Maqam Nawa Athar",
	"Hungarian minor, Mela Simhendramadhyamam",	
	"Makam Rengidil",
	"Minor Gipsy, Mela Shanmukhapriya",
	"Mela Syamalangi",	
	"Mela Varunapriya",
	"Ascending melodic minor, Jazz minor 1st mode, Minor-major 13th chord, Mela Gaurimanohari",
	-- Kaphi That
	"Rag Nayaki Kanhra",
	"Rag Kafi",	
	"Minor 13th chord, Ancient Phrygian, Medieval Dorian, Mela Kharaharapriya",
	"Safi al-Din's Maqam Higazi",
	"Murcchana Uttaramandra",
	"Murcchana Suddhamadhya",
	"Harmonic minor, Mela Kirvani",
	"Makam Sehnaz Buselik",
	-- Asavari That
	"Rag Darbari Kanhra",
	"Rag Desi",
	"Natural minor, Ancient Aeolian, Mela Natabhairavi", 
	"Makam Ussak",
	"Makam Huseyniasiran",
	"Maqam Bayati",
	"Murcchana Suddhashadja",
	"Makam Necid Huseyni",
	"Mela Jhankaradhvani",
	"Half-diminished 13th chord", 
	"Jazz minor 6th mode (Minor Locrian, 'Half-dimished' scale)",
	"Makam Saba",
	"Mela Visvambari",	
	"Rag Anand Bhairav",
	"Mela Gamanasrama",
	"Petrushka Scale, Mela Ramapriya",	
	-- Shri That
	"Rag Dipak",
	"Mela Namanarayani",
	"Mela Dhavalambari",						
	"Mela Hatakambari",
	"Mela Suryakantam",
	"Harmonic minor inverse, Mela Cakravaka",
	"Sundanese Mode Pelog Saptanada",
	-- Bhairava That
	"Rag Ramkali",
	"Rag Bhairav",
	"Rag Prabhat",
	"Rag Shiv Bhairav",
	"Rag Kaligada",
	"Major Gypsy, Mela Mayamalavagaula", 
	"Harmonic major inverse, Phrygian dominant, Mela Vakulabharanam",
	"Mela Gayakapriya",
	"Mela Divyamani",	
	"Mela Suvarnangi",
	"Mela Shadvidhamargini",
	"Rag Multani",
	"Chromatic Lydian inverse, Mela Subhapantuvarali",
	"Murcchana Matsarikrta",
	"Mela Bhavapriya",
	"Mela Gavambhodhi",
	"Mela Rupavati",
	"Neapolitan major, Mela Kokilapriya",
	"Jazz Minor 2nd mode (Dorian flat 2), Mela Natakapriya",
	"Neapolitan minor, Mela Dhenuka",
	-- Bhairavi That
	"Ancient Dorian, Medieval Phrygian, Mela Hanumatodi",
	"Makam Ferahnuma",
	"Rag Asavari",
	"Mela Senavati",
	"Makam Arak",
	"Murcchana Uttarayata",
	"Ancient Mixolydian, Medieval Locrian",
	"Jazz minor 7th mode (Super Locrian, Altered dominant scale)",
	"Mela Raghupriya",
	"Mela Pavani",
	"Mela Navanitam",
	"Mela Jhalavarali",
	"Mela Jalarnavam",
	"Mela Salagam",
	"Mela Tanarupi",
	"Mela Manavati",
	"Mela Vanaspati", 
	"Mela Ganamurti", 
	"Mela Ratnangi", 
	"Chromatic Mixolydian",
	"Chromatic Dorian, Mela Kanakangi",

	-- Hexatonik
	"Blues scale 1, Rag Nilesvari",
	"Whole-tone scale, Messiaen's 1st mode",
	"Augmented major 11th chord",
	"Augmented dominant 11th chord",
	"Major 11th chord",
	"Dominant 11th chord",
	"Minor-major 11th chord",
	"Rag Suha",
	"Minor 11th chord",
	"Rag Marva",
	"Rag Pancham",
	"Rag Bilaskhani Todi",
	"Half-diminished 11th chord",
	"Diminished 11th chord",
	"Messiaen's 5th mode",

	-- Pentatonik
	"Rag Shankar",
	"Rag Hindol",
	"Rag Malsri",
	"Lydian pentatonic",
	"Rag Khamaji Durga",
	"Sundanese mode Sorog Madenda",
	"Ionian pentatonic, Japanese mode (?) Ryukyu",
	"Sundanese mode Pelog Pancanada",
	"Sundanese mode Pelog Degung",
	"Rag Candrakauns",
	"Rag Malkauns",
	"Blues minor",
	"Thai mode 6",
	"Rag Dhani",
	"Minor pentatonic",
	"Rag Jaykauns",
	"Rag Madhyamat Sarang",
	"Rag Sarang",
	"Suspended pentatonic, Japanese mode Yo, Rag Megh",
	"Thai mode 2",
	"Blues major, Rag Durga",
	"Japanese mode (?) Han-kumoi",
	"Augmented major 9th chord",
	"Augmented dominant 9th chord",
	"Major 9th chord",
	"Dominant 9th chord, Dominant pentatonic",
	"Rag Bhupali",
	"Major pentatonic",
	"Minor-major 9th chord",
	"Minor 9th chord",
	"Dorian pentatonic, Rag Sivranjini", 
	"Thai mode 1",
	"Japanese mode In (?), Rag Samant",
	"Half-diminished 9th chord",
	"Diminished 9th chord",
	"Rag Gunkali",
	"Japanese mode Iwato",
	"Altered pentatonic",
	"Rag Reva",
	"Rag Bibhas",
	"Javanese mode Surupan Miring",
	"Javanese mode Surupan Ajeng",
	"Javanese mode Surupan Melog",
	"Rag Bhupal Todi",
	"Balinese mode Selisir",
	"Half-diminished minor 9th chord",
	"Diminished minor 9th chord",

	-- Tetratonik
	"Augmented major 7th chord",
	"Augmented 7th chord",
	"Major 7th chord",
	"Dominant 7th chord",
	"Dominant 7th flat five chord",
	"Minor-major 7th chord",
	"Minor 7th chord, Chinese mode Bi Yu",
	"Half-diminished 7th chord",
	"Diminished 7th chord",
	"Eskimo tetratonic",
	"Warao tetratonic",

	-- Tritonik
	"Japanese mode Sansagari",
	"Warao tritonic",
	"Augmented triad",
	"Major triad, Peruvian tritonic",
	"Minor triad, Ute tritonic",
	"Diminished triad",

	-- Ditonik
	"Minor 7th, Warao ditonic",
	"Minor 6th",
	"Pure 5th, Japanese mode Niagari",
	"Ascending tritone",
	"Descending tritone",
	"Pure 4th, Japanese Mode Honchoshi",
	"Major 3rd",
	"Minor 3rd"
}

Modusname = function(x) if x >= 0 then return Modusnamen[x + 1] else return " " end end

Modmatrixnamen = {
	"LFO1",
	"LFO2",
	"LFO3",
	"LFO4",
	"Env 1",
	"Env 2",
	"Env 3",
	"Env 4"
}

Modmatrixname = function(x) if x >= 0 then return Modmatrixnamen[x + 1] else return " " end end

Voicemodenamen = {
	"Tenuto",
	"Portamento",
	"Legato"
}

Voicemodename = function(x) if x >= 0 then return Voicemodenamen[x + 1] else return " " end end

LFOTypnamen = {
	"Sine",
	"Triangle",
	"Ramp Up",
	"Ramp Down",
	"Square",
	"Drift"
}

LFOTypname = function(x) if x >= 0 then return LFOTypnamen[x + 1] else return " " end end

Filterbedingungsnamen = {
	"all",
	"is equal",
	"is unequal",
	"less than",
	"greater than",
	"is inside",
	"is outside"
}

Filterbedingungsname = function(x) if x >= 0 then return Filterbedingungsnamen[x + 1] else return " " end end

FFTGroessennamen = {
	"small",
	"medium",
	"large"
}

FFTGroessenname = function(x) if x >= 0 then return FFTGroessennamen[x + 1] else return " " end end

Hopfaktornamen = {
	"/ 4",
	"/ 8",
	"/ 16",
	"/ 32"
}

Hopfaktorname = function(x) if x >= 0 then return Hopfaktornamen[x + 1] else return " " end end

Fenstertypnamen = {
	"Hamming",
	"Blackman",
	"Blackman-Harris",
	"Triangular",
	"Nuttal",
	"Nuttal-Blackman",
	"Flat Top",
	"Rectangular"
}

Fenstertypname = function(x) if x >= 0 then return Fenstertypnamen[x + 1] else return " " end end

Transformschlagname = function(x) if x < 0 then return " " else return Zahlname(x + 1) end end

Filterkanalname = function(x) if x < 0 then return " " else return Kanalname(x) end end

Oktavenname = function(x) return tostring(x - 3) end

Pfeifenbasisname = function(x) if x >= 0 then return "/" .. tostring(x + 1) else return " " end end

Richtungsnamen = {
	"up",
	"down"
}

Richtungsname = function(x) if x >= 0 then return Richtungsnamen[x + 1] else return " " end end

Systemnamen = {
	"auto",
	"upper",
	"lower"
}

Systemname = function(x) if x >= 0 then return Systemnamen[x + 1] else return " " end end

Vorzeichennamen = {
	"auto",
	"sharp",
	"flat"
}

Vorzeichenname = function(x) if x >= 0 then return Vorzeichennamen[x + 1] else return " " end end

TICKBASIS = 480

Seqtickname = function(x) 
	Res = ""
	Zaehlzeit = math.floor(x / TICKBASIS)
	if (Zaehlzeit > 0)
	then
		x = math.fmod(x, TICKBASIS)
		Res = Res .. tostring(Zaehlzeit) .. "/4 "
	end
	t2 = math.floor(TICKBASIS / 2)
	Zaehlzeit = math.floor(x / t2)
	if (Zaehlzeit > 0)
	then
		x = math.fmod(x, t2)
		Res = Res .. tostring(Zaehlzeit) .. "/8 "
	end
	Res = Res .. tostring(x) .. "t"
	return Res
end

Transformtickname = function(x) if x < 0 then return " " else return Seqtickname(x) end end

Filterstatusnamen = {
	"Note",
	"Pitch",
	"Key Press.",
	"Program",
	"Chan Press.",
	"Control"
}

Filterstatusname = function(x) if x < 0 then return " " else return Filterstatusnamen[x + 1] end end

Tonfilter_Controllermodus = false

Tonfiltername = function(x) 
	if x < 0 
	then return " " 
	else 
		if Tonfilter_Controllermodus 
		then return Controllername(x) 
		else return Tonname(x)
		end 
	end 
end

Wertfilter_GMIModus = false

Wertfiltername = function(x) 
	if x < 0 
	then return " " 
	else 
		if Wertfilter_GMIModus 
		then return Programmname(x) 
		else return Zahlname(x)
		end 
	end 
end

Transformopnamen = {
	"none",
	"replace by",
	"add",
	"sub",
	"mul",
	"div",
	"max",
	"min",
	"quantize",
	"mirror",
	"add random",
	"clip",
	"invert",
	"random",
	"lin. scale",
	"exp. scale"
}

Transformopname = function(x) if x < 0 then return " " else return Transformopnamen[x + 1] end end

SchlagAktion_Floatmodus = false

Schlagaktionname = function(x)
	if x < 0
	then return " "
	else
		if SchlagAktion_Floatmodus
		then return tostring(math.floor(40.0 * (x / 31.0)) / 10.0)
		else return tostring(x)
		end
	end
end

maxt = 480 * 4

TickAktion_Floatmodus = false

Tickaktionname = function(x)
	if x < 0
	then return " "
	else
		if TickAktion_Floatmodus
		then return tostring(math.floor(400.0 * (x / maxt)) / 100.0)
		else return tostring(x)
		end
	end
end

maxl = 480 * 64

LaengenAktion_Floatmodus = false

Laengenaktionname = function(x)
	if x < 0
	then return " "
	else
		if LaengenAktion_Floatmodus
		then return tostring(math.floor(400.0 * (x / maxl)) / 100.0)
		else return Zahlname(x)
		end
	end
end

TonAktion_Controllermodus        = false
TonAktion_Tonmodus               = false
TonAktion_Floatmodus             = false

Tonaktionname = function(x)
	if x < 0
	then return " "
	else
		if TonAktion_Controllermodus
		then return Controllername(x)
		else 
			if TonAktion_Tonmodus
			then return Tonname(x)
			else 
				if TonAktion_Floatmodus
				then return tostring(math.floor(40.0 * (x / 127.0)) / 10.0) 
				else return Zahlname(x)
				end
			end
		end
	end
end

WertAktion_Floatmodus = false
WertAktion_GMIModus = false

Wertaktionname = function(x)
	if x < 0
	then return " "
	else
		if WertAktion_GMIModus
		then return Programmname(x)
		else
			if TonAktion_Floatmodus
			then return tostring(math.floor(40.0 * (x / 127.0)) / 10.0) 
			else return Zahlname(x)
			end
		end
	end
end

